#! /usr/bin/perl

use strict;

my $duration;

while( my $line = <> ) {
  chomp $line;
  chomp $line;

  if( $line =~ /<frame duration="([0-9]+)">/ ) {
    $duration = $1;
  }

  elsif( $line =~ /<row>([0-9A-F]+)<\/row>/ ) {
    my $row_data = $1;
    my $pixel_data;
    for( my $i = 0; $i < length( $row_data ); $i += 2 ) {
      $pixel_data .= substr( $row_data, $i, 1 );
    }
    $pixel_data =~ s/([0-9A-F][0-9A-F])/0x\1, /g;
    print( $pixel_data );
  }

  elsif( $line =~ /<\/frame>/ ) {
    my $ticks = $duration / 20;
    printf( "0x%02X, 0x%02X, ", ($ticks >> 8) & 0xFF, $ticks & 0xFF );
  }

  print( "\n" );
}

